/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package jp.glassfish.sparrow.servlet3_0;

import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.servlet.AsyncContext;
import javax.servlet.ServletException;

/**
 *
 * @author Captain
 */
public class AsyncChatMessage implements Runnable {

    private AsyncContext aCtx;
    private static int messageCount;

    public AsyncChatMessage(AsyncContext aCtx) {
        this.aCtx = aCtx;
    }

    public void run() {
        ArrayList messageList = (ArrayList) aCtx.getRequest().getServletContext().getAttribute("message");
        if (aCtx.getRequest().getParameterMap().containsKey("name") &&
                aCtx.getRequest().getParameterMap().containsKey("message")) {
            try {
                String name = aCtx.getRequest().getParameter("name");
                String message = aCtx.getRequest().getParameter("message");
                addMessage(messageList, name, message);
                aCtx.getRequest().getRequestDispatcher("/chat.jsp").forward(aCtx.getRequest(), aCtx.getResponse());
            } catch (ServletException ex) {
                Logger.getLogger(AsyncChatMessage.class.getName()).log(Level.SEVERE, null, ex);
            } catch (IOException ex) {
                Logger.getLogger(AsyncChatMessage.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
    }

    @SuppressWarnings("unchecked")
    private static synchronized void addMessage(final ArrayList messegeList, final String name, final String message) {
        final StringBuilder messageBuffer = new StringBuilder(new SimpleDateFormat("dd/MM/yyyy HH:mm:ss").format(Calendar.getInstance().getTime()));
        messageBuffer.append(" ").append(name).append(" ").append(message);
        messegeList.add(messageCount, name);
        messageCount++;
        if (messageCount == Integer.MAX_VALUE) {
            messageCount = 0;
        }
    }
}
